%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%% General program %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%% Initialization %%%%%%%%%%%%%%%%%%%%%%%%
close all;clear all;
ntirage=1000;% number of random simulation. Set to 1000 (or more) for accurate results
sigma=0.075;% standard deviation of the noise process
beta=0.075;%it corresponds to the value of the beta parameter in the effort dynamics
cost=1.5;%it corresponds to the cost
pim=0.2;% pi min
emin=0.05;% minimum effort
emax=1;%maximum effort
amin=0;% minimum value of the tax
amax=4.5;% maximum value of the tax
alpha=0.25;%value of the sigmoid predation consumption
r=0.25;%value of the logistic growth parameter
K=4;%value of the logistic growth parameter
bmax=6;% maximum biomass for the state space
bmin=0;% minimum biomass for the state space
eft=0.7;% for the flat tax manager: the effort for which the fee a(t) reaches the maximum fee amax.
price=4.5;%value of the price
timehorizon=100;%Time horizon

%%%%%%%%%%%%%%%% discretization of the space: x corresponds to the biomass
%%%%%%%%%%%%%%%% and y to the effort
npasX=51;npasY=51;% discretization of the state space. Set to 51 (or more) for accurate results
pasX=(bmax-bmin)/npasX;pasY=emax/npasY;% calculation of the spatial resolution
Xmin=(pim+cost)/price;%calculation of the minimum biomass (constraint)

[X,Y] = ndgrid((bmin+pasX/2):pasX:(bmax-pasX/2), (pasY/2):pasY:(emax-pasY/2));% spatial grid
xdis=pasX/2:bmax/(npasX):(bmax-pasX/2);ydis=pasY/2:emax/(npasY):(emax-pasY/2);% discretized vector of the x-axis and the y-axis
yeq=r.*(K-xdis).*(xdis-alpha)./xdis;% equilibrium
ymin=[0 emax];xmin=[Xmin Xmin];% for graphical purposes

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%% Calculation of SOS %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%  Robustness to knowledge K1: EW, MSY and OAE managers
%%%%%%%%%%%%%%  Robustness to knowledge K2: MSY and OAE managers
%%%%%%%%%%%%%%  Robustness to knowledge K3: OAE manager
%%%%%%%%%%%%%%  Robustness to knowledge K4: FT manager
coeK1=1;%coefficient of under/overestimation for K1;
coeK2=1;%coefficient of under/overestimation for K2;
coeK3=1;%coefficient of under/overestimation for K3;
coeK4=1;%coefficient of under/overestimation for K4;
SOSEW_EF; % Calculation of the SOS of the EW manager
SOSMSY_EF;% Calculation of the SOS of the MSY manager
SOSOAE_EF;% Calculation of the SOS of the OAE manager
SOSALF_EF;% Calculation of the SOS of the ALF manager
SOSFT_EF;% Calculation of the SOS of the FT manager


