%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%% Program for the MSY manager %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xMSY=(K*coeK2+alpha)/2;%calculation of the biomass that support MSY
%%%%%%%%%%%%%%%%%%%%%%%%%%% calculation for each initial conditions
for i=1:length(xdis) 
    x(1)=xdis(i);%initial condition  for the biomass
    for j=1:length(ydis)
        y(1)=ydis(j);%initial condition  for the effort
        failure=0;%initialization of the number of failure
        for k=1:ntirage     
            failurep=0;            
            for t=2:timehorizon
                if y(1)<emin | x(1)<Xmin
                    failurep=failurep+1;
                end
                noise=randn(1,1)*sigma;% calculation of the noise at each time step
                Xp=x(t-1);
                Yp=y(t-1);
                for timebis=1:10% discretization because of the non linearity of the dynamics
                        Xp=Xp+(-y(t-1)*Xp+r*(Xp-alpha)*(K-Xp))*0.1;%dynamics of the biomass
                end
                x(t)=Xp+noise;
                if x(t)<0
                    x(t)=0;
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%% Decision-Making
                if x(t-1)*coeK1<xMSY%biomass lower than the biomass that support MSY
                     for timebis=1:10% discretization because of the non linearity of the dynamics
                         Yp=Yp+beta*Yp*(price*x(t-1)-cost-amax)*(1-Yp)*0.1;%maximum tax/dynamics of the effort
                     end   
                else%biomass higher than the biomass that support MSY
                     for timebis=1:10% discretization because of the non linearity of the dynamics
                         Yp=Yp+beta*Yp*(price*x(t-1)-cost-amin)*(1-Yp)*0.1;%minimum tax/dynamics of the effort
                     end
                end
                y(t)=Yp;
                if y(t)<emin | x(t)<Xmin
                   y(t)=emin;x(t)=0;%for graphical purposes
                   failurep=failurep+1;%failure of the simulation
                end               
            end
            if failurep>0
                failure=failure+1;%increase the number of failures
            end
        end
        Pf(i,j)=failure/ntirage;%probability of failure: number of failure divided by the number of random simulations
    end
end
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Graphics 
h=figure;
hold on
imagesc(ydis,xdis,(1-Pf));
set(gca,'FontSize',12,'fontweight','b');
plot(yeq,xdis,'k','LineWidth',3)
hold on
plot(ymin,xmin,'k','LineWidth',3)
plot(ones(2)*emin,[0 10],'k','LineWidth',3)
xlabel('Effort e','fontsize',14,'fontweight','b');
ylabel('Biomass x','fontsize',14,'fontweight','b');
annotation(h,'textbox',...
    [0.15 0.7 0.14 0.14],...
    'String',{'SOS'},...
    'FontWeight','bold',...
    'FontSize',12,...
    'FontName','Times New Roman',...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'BackgroundColor',[1 1 .6],...
    'Edgecolor',[.7 .7 .7]);
 xlim([0 emax]);ylim([0 bmax]);
 colorbar
 vs=[0.9,0.9];
[Ccs,hcs] = contour(ydis,xdis,(1-Pf),vs,'Fill','off','color','k','LineWidth',4,'LineColor','white','LineStyle','-');
saveas(h,'SOSMSY_EF','fig');close(h);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% end of graphics, the figure is saved