%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%% Program for the OAE manager %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%% Calculation is based on dynamic programming (Bellman):
%%%%%%%%%%%% 2 value functions are calculated for the tranistion matrix:
%%%%%%%%%%%%      - one for the real dynamics;
%%%%%%%%%%%%      - one for the perceived dynamics.
%%%%%%%%%%%% Note: accurate calculations requires finer discretization (101)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


V=X*0+1;V(X<Xmin)=0;V(Y<emin)=0;% initialisation of the value function
Vinit=V;% keep the initial matrix for boundary conditions
p=zeros(npasX,npasY,npasX,npasY,11);p2=p;%initialization of the transition matrix
for i=1:npasX
    i
    for j=1:npasY
            for k1=1:11
                    u1=-amax+(k1-1)/10*(amax-amin);
                    noise=randn(1,ntirage)*sigma*coeK3;% calculation of the noise at each time step
                    noise2=randn(1,ntirage)*sigma;% calculation of the noise at each time step
                    Xincr=X(i,j)*ones(1,ntirage);%dynamics perceived by decision-maker
                    Xincr2=X(i,j)*ones(1,ntirage);%real dynamics 
                    for timebis=1:10% discretization because of the non linearity of the dynamics
                        Xp=Xincr+...
                            +(r*(K*coeK2-Xincr*coeK1).*(Xincr*coeK1-alpha)-Y(i,j)*coeK4*Xincr*coeK1)*0.1;%dynamics perceived by decision-maker
                        Xincr=Xp;
                        Xp2=Xincr2+...
                            +(r*(K-Xincr2).*(Xincr2-alpha)-Y(i,j)*Xincr2)*0.1;%real dynamics 
                        Xincr2=Xp2;
                    end
                    Xp=Xp+noise;
                    Xp2=Xp2+noise2;
                    Xp(find(Xp>bmax))=bmax-pasX/2;%Xp2(find(Xp2>bmax))=bmax-pasX/2;
                    Yincr=Y(i,j)*coeK4;%dynamics perceived by decision-maker
                    Yincr2=Y(i,j);%real dynamics
                    for timebis=1:10% discretization because of the non linearity of the dynamics
                        Yp=Yincr+beta*Yincr*(price*X(i,j)*coeK1-cost+u1)*(1-Yincr)*0.1;%dynamics perceived by decision-maker
                        Yincr=Yp;
                        Yp2=Yincr2+beta*Yincr2*(price*X(i,j)-cost+u1)*(1-Yincr2)*0.1;%real dynamics
                        Yincr2=Yp2;
                    end
                    [aqa m]=min(abs(Yp-ydis));%dynamics perceived by decision-maker
                    [aqa m2]=min(abs(Yp2-ydis));%real dynamics
                    for l=1:npasX 
                        p(i,j,l,m,k1)=length(find(Xp>(X(l,1)-pasX/2)&Xp<=(X(l,1)+pasX/2)))/ntirage;%transtion matrix of the perceived system
                        p2(i,j,l,m2,k1)=length(find(Xp2>(X(l,1)-pasX/2)&Xp2<=(X(l,1)+pasX/2)))/ntirage;%%transtion matrix of the real system
                    end
            end        
    end
end
V2=Vinit;V=Vinit;
toto=zeros(npasX,npasY);
%%%%%%%%%%%%%%%%%%%%%% boucle sur t: Bellman principle, backwards technique
for t=timehorizon:-1:1
    Vd=V;Vd2=V2;% the two value functions (perceived and real)
    for i=1:npasX
        for j=1:npasY
                maxV=-1;            
                for k1=1:1:11
                    toto(:,:)=p(i,j,:,:,k1);
                    V(i,j)=((sum(sum(Vd(:,:).*toto.*Vinit))))*Vinit(i,j);
                    if V(i,j)>maxV
                        maxV=V(i,j);
                        if maxV>1
                            maxV=1;
                        end
                        u1mb(i,j)=k1;
                    end
                end
                V(i,j)=maxV;   
                toto2(:,:)=p2(i,j,:,:,u1mb(i,j));
                V2(i,j)=((sum(sum(Vd2(:,:).*toto2.*Vinit))))*Vinit(i,j);
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Graphics 
h=figure;
hold on
imagesc(ydis,xdis,V2);
set(gca,'FontSize',12,'fontweight','b');
plot(yeq,xdis,'k','LineWidth',3)
hold on
plot(ymin,xmin,'k','LineWidth',3)
plot(ones(2)*emin,[0 10],'k','LineWidth',3)
xlabel('Effort e','fontsize',14,'fontweight','b');
ylabel('Biomass x','fontsize',14,'fontweight','b');
annotation(h,'textbox',...
    [0.15 0.7 0.14 0.14],...
    'String',{'SOS'},...
    'FontWeight','bold',...
    'FontSize',12,...
    'FontName','Times New Roman',...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'BackgroundColor',[1 1 .6],...
    'Edgecolor',[.7 .7 .7]);
xlim([0 emax]);ylim([0 bmax]);
colorbar
vs=[0.9,0.9]; 
[Ccs,hcs] = contour(ydis,xdis,V2,vs,'Fill','off','color','k','LineWidth',4,'LineColor','white','LineStyle','-');
saveas(h,'SOSOAE_EF','fig');close(h);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% end of graphics, the figure is saved